﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using ReptileParkAPI.Data;

namespace ReptileParkAPI.Migrations
{
    [DbContext(typeof(ReptileParkDbContext))]
    partial class ReptileParkDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("ProductVersion", "5.0.17")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("LizardParkRanger", b =>
                {
                    b.Property<int>("LizardsId")
                        .HasColumnType("int");

                    b.Property<int>("ParkRangersId")
                        .HasColumnType("int");

                    b.HasKey("LizardsId", "ParkRangersId");

                    b.HasIndex("ParkRangersId");

                    b.ToTable("LizardParkRanger");
                });

            modelBuilder.Entity("ReptileParkAPI.Models.Lizard", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(60)
                        .HasColumnType("nvarchar(60)");

                    b.Property<double>("ScurrySpeed")
                        .HasColumnType("float");

                    b.Property<double>("Weight")
                        .HasColumnType("float");

                    b.HasKey("Id");

                    b.ToTable("Lizards");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Name = "Liz",
                            ScurrySpeed = 2.5,
                            Weight = 5.0
                        },
                        new
                        {
                            Id = 2,
                            Name = "Pauline",
                            ScurrySpeed = 5.5,
                            Weight = 8.0
                        },
                        new
                        {
                            Id = 3,
                            Name = "Gary",
                            ScurrySpeed = 1.8999999999999999,
                            Weight = 3.0
                        });
                });

            modelBuilder.Entity("ReptileParkAPI.Models.ParkRanger", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("FavouriteReptile")
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<string>("MembershipTag")
                        .IsRequired()
                        .HasMaxLength(15)
                        .HasColumnType("nvarchar(15)");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(100)
                        .HasColumnType("nvarchar(100)");

                    b.Property<double>("Weight")
                        .HasColumnType("float");

                    b.HasKey("Id");

                    b.ToTable("ParkRangers");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            FavouriteReptile = "Snake",
                            MembershipTag = "PR232twtq34tq9",
                            Name = "Jimbo",
                            Weight = 86.0
                        },
                        new
                        {
                            Id = 2,
                            FavouriteReptile = "Lizard",
                            MembershipTag = "PR232twtq34tq3",
                            Name = "Billy Bob",
                            Weight = 67.0
                        });
                });

            modelBuilder.Entity("ReptileParkAPI.Models.Terrarium", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<double>("CubicCm")
                        .HasColumnType("float");

                    b.Property<int?>("LizardId")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("LizardId")
                        .IsUnique()
                        .HasFilter("[LizardId] IS NOT NULL");

                    b.ToTable("Terraria");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            CubicCm = 57.0
                        },
                        new
                        {
                            Id = 2,
                            CubicCm = 109.0
                        });
                });

            modelBuilder.Entity("LizardParkRanger", b =>
                {
                    b.HasOne("ReptileParkAPI.Models.Lizard", null)
                        .WithMany()
                        .HasForeignKey("LizardsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ReptileParkAPI.Models.ParkRanger", null)
                        .WithMany()
                        .HasForeignKey("ParkRangersId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("ReptileParkAPI.Models.Terrarium", b =>
                {
                    b.HasOne("ReptileParkAPI.Models.Lizard", "Lizard")
                        .WithOne("Terrarium")
                        .HasForeignKey("ReptileParkAPI.Models.Terrarium", "LizardId");

                    b.Navigation("Lizard");
                });

            modelBuilder.Entity("ReptileParkAPI.Models.Lizard", b =>
                {
                    b.Navigation("Terrarium");
                });
#pragma warning restore 612, 618
        }
    }
}
